% vykresleni.m - Numericke nalezeni extremu fce vice promennych
% pouziti funkce 'fminsearch'

clear all;close all;clc

x0 = [0,0];         % pocatecni bod optimalizace
[x,fval,exitflag,output] = fminsearch(@rosenbrock,x0)
% x ... nalezene reseni (minimum) ve tvaru [x1,x2]
% fval ... hodnota cilove fce. pro nalezene x
% exitflag ... 1 - fminsearch dokonvergoval k x
%              0 - prekrocen max. pocet iteraci
%             -1 - vypocet prerusen vystupni funkci
% output ... vraci structure output s informacemi o vypoctu

x1=[-1.2: .02: 1.2]';    % definujeme x1<-1.2;1.2>
x2=[-0.1: .02: 1.2]';    % definujeme x2<-0.1;1.2>

for f=1:size(x1,1) % cyklus pres vsechny x1
    for g=1:size(x2,1) % cyklus pres vsechny x2
        Z(f,g) = rosenbrock([x1(f),x2(g)]);
        % do pole Z se ukladaji hodnoty cilove fce
    end
end

% Vykresleni plochy cilove fce ve 3D
figure
surf(x1, x2, Z') % nakresli plochu (x1(i), x2(j), Z(i,j))
xlabel('x_1');ylabel('x_2');zlabel('Cilova fce')

% Vykresleni 'vrstevnic' podle cilove fce
figure
[X,Y] = meshgrid(x1,x2); % z definovanych vektoru x1, x2 vytvori 2D sit
contour(X,Y,Z',150); % podle hodnoty Z vykresli 50 vrstevnic nad siti XY
hold on
plot(x(1),x(2),'ro') % zakresleni zjisteneho bodu lok. minima